# UIBUILDER for Node-RED Security Policy

The maintainers of UIBUILDER for Node-RED take security bugs seriously. We appreciate your efforts to responsibly disclose your findings, and will make every effort to acknowledge your contributions.

## Reporting Security Issues

To report a security issue, please use the GitHub Security Advisory ["Report a Vulnerability"](https://github.com/totallyinformation/node-red-contrib-uibuilder/security/advisories/new) page for UIBUILDER.

The maintainers will send a response indicating the next steps in handling your report. 
After the initial reply to your report, the security team will aim to keep you informed of the progress towards a fix 
and full announcement, and may ask for additional information or guidance.

Please do not release information about reported security issues to any 3rd-party without checking in with the maintainers first
since this may result in other people being put at risk.

Report security bugs in third-party modules to the person or team maintaining the module. You can also report a vulnerability through the [npm contact form](https://www.npmjs.com/support) by selecting "I'm reporting a security vulnerability".

## Supported Versions

Generally, only the current published version of UIBUILDER will receive security fixes. Please upgrade to the latest version of UIBUILDER and test before submitting a security issue.

If for some reason you cannot upgrade to the latest version, please make the reason clear in your security report and the maintainers will do their best to provide
a fix. But please bear in mind that it may not be possible to fix vulnerabilities in older versions.
